searchNodes=[{"ref":"Ueberauth.Strategy.Apple.html","title":"Ueberauth.Strategy.Apple","type":"module","doc":"Google Strategy for Überauth."},{"ref":"Ueberauth.Strategy.Apple.html#auth/1","title":"Ueberauth.Strategy.Apple.auth/1","type":"function","doc":""},{"ref":"Ueberauth.Strategy.Apple.html#credentials/1","title":"Ueberauth.Strategy.Apple.credentials/1","type":"function","doc":"Includes the credentials from the Apple response."},{"ref":"Ueberauth.Strategy.Apple.html#default_options/0","title":"Ueberauth.Strategy.Apple.default_options/0","type":"function","doc":""},{"ref":"Ueberauth.Strategy.Apple.html#extra/1","title":"Ueberauth.Strategy.Apple.extra/1","type":"function","doc":"Stores the raw information (including the token) obtained from the google callback."},{"ref":"Ueberauth.Strategy.Apple.html#handle_request!/1","title":"Ueberauth.Strategy.Apple.handle_request!/1","type":"function","doc":"Handles initial request for Apple authentication."},{"ref":"Ueberauth.Strategy.Apple.html#info/1","title":"Ueberauth.Strategy.Apple.info/1","type":"function","doc":"Fetches the fields to populate the info section of the Ueberauth.Auth struct."},{"ref":"Ueberauth.Strategy.Apple.html#uid/1","title":"Ueberauth.Strategy.Apple.uid/1","type":"function","doc":"Fetches the uid field from the response."},{"ref":"Ueberauth.Strategy.Apple.OAuth.html","title":"Ueberauth.Strategy.Apple.OAuth","type":"module","doc":"OAuth2 for Apple. Add client_id and client_secret to your configuration: config :ueberauth, Ueberauth.Strategy.Apple.OAuth, client_id: System.get_env(&quot;APPLE_CLIENT_ID&quot;), client_secreat: System.get_env(&quot;APPLE_CLIENT_SECRET&quot;)"},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#authorize_url/2","title":"Ueberauth.Strategy.Apple.OAuth.authorize_url/2","type":"function","doc":"Builds the URL to the authorization endpoint. Example def authorize_url(client, params) do client |&gt; put_param(:response_type, &quot;code&quot;) |&gt; put_param(:client_id, client.client_id) |&gt; put_param(:redirect_uri, client.redirect_uri) |&gt; merge_params(params) end Callback implementation for OAuth2.Strategy.authorize_url/2."},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.Apple.OAuth.authorize_url!/2","type":"function","doc":"Provides the authorize url for the request phase of Ueberauth. No need to call this usually."},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#client/1","title":"Ueberauth.Strategy.Apple.OAuth.client/1","type":"function","doc":"Construct a client for requests to Apple. This will be setup automatically for you in Ueberauth.Strategy.Apple. These options are only useful for usage outside the normal callback phase of Ueberauth."},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#get/4","title":"Ueberauth.Strategy.Apple.OAuth.get/4","type":"function","doc":""},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#get_access_token/2","title":"Ueberauth.Strategy.Apple.OAuth.get_access_token/2","type":"function","doc":""},{"ref":"Ueberauth.Strategy.Apple.OAuth.html#get_token/3","title":"Ueberauth.Strategy.Apple.OAuth.get_token/3","type":"function","doc":"Builds the URL to token endpoint. Example def get_token(client, params, headers) do client |&gt; put_param(:code, params[:code]) |&gt; put_param(:grant_type, &quot;authorization_code&quot;) |&gt; put_param(:client_id, client.client_id) |&gt; put_param(:client_secret, client.client_secret) |&gt; put_param(:redirect_uri, client.redirect_uri) |&gt; merge_params(params) |&gt; put_headers(headers) end Callback implementation for OAuth2.Strategy.get_token/3."},{"ref":"UeberauthApple.html","title":"UeberauthApple","type":"module","doc":""},{"ref":"UeberauthApple.html#generate_client_secret/1","title":"UeberauthApple.generate_client_secret/1","type":"function","doc":"Generates client secret."},{"ref":"UeberauthApple.html#uid_from_id_token/1","title":"UeberauthApple.uid_from_id_token/1","type":"function","doc":""},{"ref":"readme.html","title":"Überauth Apple","type":"extras","doc":"Überauth Apple Apple OAuth2 strategy for Überauth."},{"ref":"readme.html#installation","title":"Überauth Apple - Installation","type":"extras","doc":"Setup your application at Apple Developer Console. Add :ueberauth_apple to your list of dependencies in mix.exs: def deps do [{:ueberauth_apple, &quot;~&gt; 0.4&quot;}] end Add the strategy to your applications: def application do [applications: [:ueberauth_apple]] end Add Apple to your Überauth configuration: config :ueberauth, Ueberauth, providers: [ apple: {Ueberauth.Strategy.Apple, []} ] Update your provider configuration: Option 1 - Generate secret manually: If you don&#39;t have the client secret, generate the client secret: UeberauthApple.generate_client_secret(%{ client_id: &quot;com.example.service&quot;, key_id: &quot;10digitkey&quot;, team_id: &quot;teamid&quot;, private_key: &quot;-----BEGIN PRIVATE KEY-----\\n...\\n-----END PRIVATE KEY-----&quot; }) Use that if you want to read client ID/secret from the environment variables in the compile time: config :ueberauth, Ueberauth.Strategy.Apple.OAuth, client_id: System.get_env(&quot;APPLE_CLIENT_ID&quot;), client_secret: System.get_env(&quot;APPLE_CLIENT_SECRET&quot;) Option 2 - Generate secret programmatically: config :ueberauth, Ueberauth.Strategy.Apple.OAuth, client_id: System.get_env(&quot;APPLE_CLIENT_ID&quot;), client_secret: {YourApp.SomeModule, :secret_function} And implement the function to generate the secret, once you generate the secret, store it in Redis so the secret does not generate every time. function secret_function(ueberauth_config) do secret = get_secret_from_redis() if secret do secret else secret = UeberauthApple.generate_client_secret(%{ client_id: opts[:client_id], key_id: Application.get_env(:naboo, Naboo.Auth.Apple)[:key_id], team_id: Application.get_env(:naboo, Naboo.Auth.Apple)[:team_id], private_key: Application.get_env(:naboo, Naboo.Auth.Apple)[:private_key] }) set_secret_to_redis(secret) secret end end Include the Überauth plug in your controller: defmodule MyApp.AuthController do use MyApp.Web, :controller plug Ueberauth ... end Create the request and callback routes if you haven&#39;t already: scope &quot;/auth&quot;, MyApp do pipe_through :browser get &quot;/:provider&quot;, AuthController, :request get &quot;/:provider/callback&quot;, AuthController, :callback end Your controller needs to implement callbacks to deal with Ueberauth.Auth and Ueberauth.Failure responses. For an example implementation see the Überauth Example application."},{"ref":"readme.html#calling","title":"Überauth Apple - Calling","type":"extras","doc":"Since Apple only supports form post, you need to create a Sign-in button: &lt;html&gt; &lt;head&gt; &lt;/head&gt; &lt;body&gt; &lt;script type=&quot;text/javascript&quot; src=&quot;https://appleid.cdn-apple.com/appleauth/static/jsapi/appleid/1/en_US/appleid.auth.js&quot;&gt;&lt;/script&gt; &lt;div id=&quot;appleid-signin&quot; data-color=&quot;black&quot; data-border=&quot;true&quot; data-type=&quot;sign in&quot;&gt;&lt;/div&gt; &lt;script type=&quot;text/javascript&quot;&gt; AppleID.auth.init({ clientId : &#39;&lt;%= Application.get_env(:ueberauth, Ueberauth.Strategy.Apple.OAuth)[:client_id] %&gt;&#39;, scope : &#39;email name&#39;, redirectURI : &#39;&lt;%= Routes.auth_url(@conn, :callback, &quot;apple&quot;) %&gt;&#39;, state : &#39;[STATE]&#39;, usePopup : true //or false defaults to false }); &lt;/script&gt; &lt;/body&gt; &lt;/html&gt; Scope can be configured either explicitly as a scope query value on the request path or in your configuration: config :ueberauth, Ueberauth, providers: [ apple: {Ueberauth.Strategy.Apple, [default_scope: &quot;name email&quot;, callback_methods: [&quot;POST&quot;]]} ] To guard against client-side request modification, it&#39;s important to still check the domain in info.urls[:website] within the Ueberauth.Auth struct if you want to limit sign-in to a specific domain."},{"ref":"readme.html#license","title":"Überauth Apple - License","type":"extras","doc":"Please see LICENSE for licensing details."},{"ref":"contributing.html","title":"Contributing to Ueberauth Apple","type":"extras","doc":"Contributing to Ueberauth Apple"},{"ref":"contributing.html#pull-requests-welcome","title":"Contributing to Ueberauth Apple - Pull Requests Welcome","type":"extras","doc":"Fork ueberauth_apple Create a topic branch Make logically-grouped commits with clear commit messages Push commits to your fork Open a pull request against ueberauth_apple/master"},{"ref":"contributing.html#issues","title":"Contributing to Ueberauth Apple - Issues","type":"extras","doc":"If you believe there to be a bug, please provide the maintainers with enough detail to reproduce or a link to an app exhibiting unexpected behavior. For help, please start with Stack Overflow."}]